dnl  ARM mpn_invert_limb -- Invert a normalized limb.

dnl  Copyright 2001, 2009, 2011 Free Software Foundation, Inc.

dnl  This file is part of the GNU MP Library.

dnl  The GNU MP Library is free software; you can redistribute it and/or modify
dnl  it under the terms of the GNU Lesser General Public License as published
dnl  by the Free Software Foundation; either version 3 of the License, or (at
dnl  your option) any later version.

dnl  The GNU MP Library is distributed in the hope that it will be useful, but
dnl  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
dnl  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
dnl  License for more details.

dnl  You should have received a copy of the GNU Lesser General Public License
dnl  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

include(`../config.m4')

ASM_START()
PROLOGUE(mpn_invert_limb)
	ldr	r2, L(4)
L(2):	add	r2, pc, r2
	mov	r3, r0, lsr #23
	mov	r3, r3, asl #1
	ldr	r3, [r2, r3, asl #1]
	mov	r1, r3, asl #17
	mul	r12, r3, r3
	umull	r3, r2, r12, r0
	sub	r1, r1, r2, asl #1
	umull	r3, r2, r1, r1
	umull	r12, r3, r0, r3
	umull	r2, r12, r0, r2
	adds	r2, r2, r3
	adc	r12, r12, #0
	rsb	r1, r12, r1
	mvn	r2, r2, lsr #30
	add	r2, r2, r1, asl #2
	umull	r12, r3, r0, r2
	adds	r1, r12, r0
	adc	r3, r3, r0
	rsb	r0, r3, r2
	mov	pc, r14

	ALIGN(4)
L(4):	.word	approx_tab-8-1024-L(2)
EPILOGUE()

	.section .rodata
	ALIGN(2)
approx_tab:
	.word    0xffffffc0,0xfffffec0,0xfffffdc0,0xfffffcc0,0xfffffbc0,0xfffffac0,0xfffffa00,0xfffff900
	.word    0xfffff800,0xfffff700,0xfffff640,0xfffff540,0xfffff440,0xfffff380,0xfffff280,0xfffff180
	.word    0xfffff0c0,0xffffefc0,0xffffef00,0xffffee00,0xffffed40,0xffffec40,0xffffeb80,0xffffeac0
	.word    0xffffe9c0,0xffffe900,0xffffe840,0xffffe740,0xffffe680,0xffffe5c0,0xffffe500,0xffffe400
	.word    0xffffe340,0xffffe280,0xffffe1c0,0xffffe100,0xffffe040,0xffffdf80,0xffffdec0,0xffffde00
	.word    0xffffdd40,0xffffdc80,0xffffdbc0,0xffffdb00,0xffffda40,0xffffd980,0xffffd8c0,0xffffd800
	.word    0xffffd740,0xffffd680,0xffffd600,0xffffd540,0xffffd480,0xffffd3c0,0xffffd340,0xffffd280
	.word    0xffffd1c0,0xffffd140,0xffffd080,0xffffcfc0,0xffffcf40,0xffffce80,0xffffcdc0,0xffffcd40
	.word    0xffffcc80,0xffffcc00,0xffffcb40,0xffffcac0,0xffffca00,0xffffc980,0xffffc8c0,0xffffc840
	.word    0xffffc780,0xffffc700,0xffffc640,0xffffc5c0,0xffffc540,0xffffc480,0xffffc400,0xffffc380
	.word    0xffffc2c0,0xffffc240,0xffffc1c0,0xffffc100,0xffffc080,0xffffc000,0xffffbf80,0xffffbec0
	.word    0xffffbe40,0xffffbdc0,0xffffbd40,0xffffbc80,0xffffbc00,0xffffbb80,0xffffbb00,0xffffba80
	.word    0xffffba00,0xffffb980,0xffffb900,0xffffb840,0xffffb7c0,0xffffb740,0xffffb6c0,0xffffb640
	.word    0xffffb5c0,0xffffb540,0xffffb4c0,0xffffb440,0xffffb3c0,0xffffb340,0xffffb2c0,0xffffb240
	.word    0xffffb1c0,0xffffb140,0xffffb0c0,0xffffb080,0xffffb000,0xffffaf80,0xffffaf00,0xffffae80
	.word    0xffffae00,0xffffad80,0xffffad40,0xffffacc0,0xffffac40,0xffffabc0,0xffffab40,0xffffaac0
	.word    0xffffaa80,0xffffaa00,0xffffa980,0xffffa900,0xffffa8c0,0xffffa840,0xffffa7c0,0xffffa740
	.word    0xffffa700,0xffffa680,0xffffa600,0xffffa5c0,0xffffa540,0xffffa4c0,0xffffa480,0xffffa400
	.word    0xffffa380,0xffffa340,0xffffa2c0,0xffffa240,0xffffa200,0xffffa180,0xffffa140,0xffffa0c0
	.word    0xffffa080,0xffffa000,0xffff9f80,0xffff9f40,0xffff9ec0,0xffff9e80,0xffff9e00,0xffff9dc0
	.word    0xffff9d40,0xffff9d00,0xffff9c80,0xffff9c40,0xffff9bc0,0xffff9b80,0xffff9b00,0xffff9ac0
	.word    0xffff9a40,0xffff9a00,0xffff9980,0xffff9940,0xffff98c0,0xffff9880,0xffff9840,0xffff97c0
	.word    0xffff9780,0xffff9700,0xffff96c0,0xffff9680,0xffff9600,0xffff95c0,0xffff9580,0xffff9500
	.word    0xffff94c0,0xffff9440,0xffff9400,0xffff93c0,0xffff9340,0xffff9300,0xffff92c0,0xffff9240
	.word    0xffff9200,0xffff91c0,0xffff9180,0xffff9100,0xffff90c0,0xffff9080,0xffff9000,0xffff8fc0
	.word    0xffff8f80,0xffff8f40,0xffff8ec0,0xffff8e80,0xffff8e40,0xffff8e00,0xffff8d80,0xffff8d40
	.word    0xffff8d00,0xffff8cc0,0xffff8c80,0xffff8c00,0xffff8bc0,0xffff8b80,0xffff8b40,0xffff8b00
	.word    0xffff8a80,0xffff8a40,0xffff8a00,0xffff89c0,0xffff8980,0xffff8940,0xffff88c0,0xffff8880
	.word    0xffff8840,0xffff8800,0xffff87c0,0xffff8780,0xffff8740,0xffff8700,0xffff8680,0xffff8640
	.word    0xffff8600,0xffff85c0,0xffff8580,0xffff8540,0xffff8500,0xffff84c0,0xffff8480,0xffff8440
	.word    0xffff8400,0xffff8380,0xffff8340,0xffff8300,0xffff82c0,0xffff8280,0xffff8240,0xffff8200
	.word    0xffff81c0,0xffff8180,0xffff8140,0xffff8100,0xffff80c0,0xffff8080,0xffff8040,0xffff8000
ASM_END()
